#!/usr/bin/env python
#coding:utf-8

'''
from JiuJiang
树莓酱的操作实例
http:://www.shumeijiang.com
'''

import sys
import RPi.GPIO as GPIO  ##引入GPIO模块
import time              ##引入time库
from classes.mongoConn import mongoConn

pin = 18 #led灯使用的引脚

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)      ##此处采用的BCM编码 因为T型扩展板也是BCM编码 方便统一
GPIO.setup(pin, GPIO.OUT)   ##设置BCM编码下18号引脚为输出状态
GPIO.output(pin, GPIO.LOW)  ##由于跳线帽设置高电平出发，因此低电平关灯

#数据库初始化
conn = mongoConn()

#寻找可执行命令
def findTask():
    conn.set_collection('act.test') #命令表
    data = conn.get_last_data({"subject":"电灯", "status":1}) #寻找最新可执行的一条
    if not data:
        return {}

    return data


#命令执行
def runTask(act_type):
    if act_type == u'开灯':
        GPIO.output(pin, GPIO.HIGH)
        time.sleep(5)
        GPIO.output(pin, GPIO.LOW)

    elif act_type == u'关灯':
        GPIO.output(pin, GPIO.LOW)
    else:
        return False

    return True


#任务结束
def finishTask(act_id):
    if not act_id:
        return False

    conn.set_collection('act.test')
    ret = conn.update_data({'_id':act_id}, {'status':2})
    if not ret:
        return False
    return True

#执行步进
if __name__ == '__main__':
    try:
        #任务寻找
        taskData = findTask()
        if not taskData:
            sys.exit()

        #任务执行
        if not taskData['act']:
            print('act not found')
            sys.exit()

        #执行命令
        ret = runTask(taskData['act'])
        if not ret:
            print('执行失败')

        #任务结束
        finishTask(taskData['_id'])
        print('执行完成')

    except KeyboardInterrupt:
        pass

    GPIO.cleanup()





'''
t=1
while(status == 'kd'):
    print(t)
    GPIO.output(pin, GPIO.HIGH)
    time.sleep(1)
    t = t+1
    if t>=5:
        status = ''
'''

'''
if status == 'kd':
    GPIO.output(pin, GPIO.HIGH) ##高电平开灯
    time.sleep(5)  ##开灯时间 也可用while 持续点亮
    GPIO.output(pin, GPIO.LOW)
else:
    pass

GPIO.cleanup()

'''
